﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ServiceModel;

namespace EHEC_Server
{
    public partial class GenerateDataBuilder
    {

        //dieses file wird im moment nicht benötigt, da alles im global benutzt wird, bitte so belassen für den moment
        private static List<Doctor> Doctors = new List<Doctor>();
        private static List<Patient> Patients = new List<Patient>();
        private static List<Origin> Origins = new List<Origin>();
        private static List<Result> Results = new List<Result>();
        private static List<Exam> Exams = new List<Exam>();
        private static Random Rnd = new Random();


        private static List<string> FirstNames = new List<string>(new string[]
        {
            "Michael", "Andreas", "Stefan", "Ivan","Adrien"
        });

        private static List<string> LastNames = new List<string>(new string[]
        {
            "Meister", "Schär", "Eberhard", "Zingg", "Howald", "Aebi", "Feldmann"
        });

        private static List<string> Streets = new List<string>(new string[]
        {
            "Rosenauweg", "Schessstrasse", "Hardstrasse", "Gehweg", "Bananastreet", "Moosweg", "Feldstrasse"
        });

        private static List<string> Cities = new List<string>(new string[]
        {
            "Meister", "Schär", "Eberhard", "Zingg", "Howald", "Aebi", "Feldmann"
        });

        private static List<string> Regions = new List<string>(new string[]
        {
            "Aargau", "Zurich", "Graubünden","Vallhalla", "Hell", "Heaven"
        });


        private static List<string> BirthDates = new List<string>(new string[]
        {
            "2001-07-11 20:18:00.000", "1999-03-12 10:18:00.000","1980-01-21 00:18:00.000",
        });

        private static List<string> DoctorOrigins = new List<string>(new string[]
        {
            "SanktMonika", "DisneyWorld", "Kantonsspital Baden", "Online Schulung"
        });

        private static List<string> Foods = new List<string>(new string[]
        {
            "SanktMonika", "DisneyWorld", "Kantonsspital Baden", "Online Schulung"
        });

        private static List<string> Names = new List<string>(new string[]
        {
            "SanktMonika", "DisneyWorld", "Kantonsspital Baden", "Online Schulung"
        });

        private static List<int> DoctorId = new List<int>(new int[]
        {
            1, 2, 3, 4, 5, 6, 7, 8, 9, 10,
        });

        private static List<int> PatientId = new List<int>(new int[]
        {
            11, 2, 3, 4, 5, 6, 7, 8, 9, 10
        });

        private static List<int> ResultId = new List<int>(new int[]
        {
            1, 2, 3, 4, 5
        });


        public static Patient CreateRandomPatients(Patient patients)
        {
            using (EHEC_DBEntities ctx = new EHEC_DBEntities())
            {
                Random p = new Random();
                for (int i = 0; i < 50; i++)
                {
                    Patient patient = new Patient
                    {
                        PatientUid = Guid.NewGuid().ToString(),
                        FirstName = FirstNames[p.Next(0, 5)].ToString(),
                        LastName = LastNames[p.Next(0, 7)].ToString(),
                        BirthDate = Convert.ToDateTime(BirthDates[p.Next(0, 3)].ToString()),
                        Street = Streets[p.Next(0, 7)].ToString(),
                        City = Cities[p.Next(0, 7)].ToString(),
                        Region = Regions[p.Next(0, 6)].ToString()
                    };
                    //Global.GlobalInstance.DbAccess.Patients.Add(patient);
                    ctx.Patients.Add(patient);
                    ctx.SaveChanges();
                }
            }
            return patients;
        }
        public static Doctor CreateRandomDoctors(Doctor doctors)
        {
            using (EHEC_DBEntities ctx = new EHEC_DBEntities())
            {

                Random d = new Random();
                for (int i = 0; i < 50; i++)
                {
                    Doctor doctor = new Doctor
                    {
                        DoctorUid = Guid.NewGuid().ToString(),
                        FirstName = FirstNames[d.Next(0, 5)].ToString(),
                        LastName = LastNames[d.Next(0, 7)].ToString(),
                        DoctorOrigin = DoctorOrigins[d.Next(0, 4)].ToString(),
                        Region = Regions[d.Next(0, 6)].ToString()
                    };
                    //Global.GlobalInstance.DbAccess.Doctors.Add(doctor);
                    ctx.Doctors.Add(doctor);
                    ctx.SaveChanges();
                }
            }
            return doctors;
        }

        public static Origin CreateRandomOrigins(Origin origins)
        {
            using (EHEC_DBEntities ctx = new EHEC_DBEntities())
            {
                Random o = new Random();
                for (int i = 0; i < 5; i++)
                {
                    Origin origin = new Origin
                    {
                        OriginUid = Guid.NewGuid().ToString(),
                        Name = Names[o.Next(0, 5)].ToString(),
                        Food = Foods[o.Next(0, 5)].ToString(),
                        Street = Streets[o.Next(0, 5)].ToString(),
                        City = Cities[o.Next(0, 5)].ToString(),

                    };
                    ctx.Origins.Add(origin);
                    ctx.SaveChanges();
                }
            }
            return origins;
        }

        public static Result CreateRandomResults(Result results)
        {
            using (EHEC_DBEntities ctx = new EHEC_DBEntities())
            {
                Random r = new Random();
                for (int i = 0; i < 5; i++)
                {
                    Result result = new Result
                    {
                        ResultUid = Guid.NewGuid().ToString(),
                        Name = Names[r.Next(0, 5)].ToString()

                    };
                    ctx.Results.Add(result);
                    ctx.SaveChanges();
                }
            }
            return results;
        }

        public static Exam CreateRandomExams(Exam exams)
        {
            using (EHEC_DBEntities ctx = new EHEC_DBEntities())
            {
                //int DoctorAmount = Doctor.Count();
                //int PatientAmount = Patient.Count();
                //int ResultAmount = Result.Count();

                Random e = new Random();
                for (int i = 0; i < 5; i++)
                {
                    Exam exam = new Exam
                    {
                         ExamUid = Guid.NewGuid().ToString(),
                         DoctorId = DoctorId[e.Next(0, 5)],
                         PatientId = PatientId[e.Next(0, 5)],
                         ResultId = ResultId[e.Next(0, 5)]
                    };
                    ctx.Exams.Add(exam);
                    ctx.SaveChanges();

                }
                
            }
            return exams;
        }


    }
}